Minimize the Maximum Difference of Pairs - Leetcode 2616 - Python

Sdílet
Vložit
  • čas přidán 9. 07. 2024
  • Solving Leetcode 2616, Minimize the maximum difference of pairs, today's daily leetcode problem on august 8.
    🚀 neetcode.io/ - A better way to prepare for Coding Interviews
    🥷 Discord: / discord
    🐦 Twitter: / neetcode1
    🐮 Support the channel: / neetcode
    ⭐ BLIND-75 PLAYLIST: • Two Sum - Leetcode 1 -...
    💡 DYNAMIC PROGRAMMING PLAYLIST: • House Robber - Leetco...
    Problem Link: leetcode.com/problems/minimiz...
    0:00 - Read the problem
    1:10 - Drawing Explanation
    11:40 - Coding Explanation
    leetcode 2616
    #neetcode #leetcode #python

Komentáře • 70

  • @NeetCodeIO
    @NeetCodeIO  Před 11 měsíci +26

    Tried talking a bit slower in this one, let me know if it's better/worse.
    Also, I would be uploading daily but most of the daily LC problems lately have been ones I already have videos for :)

    • @thespicycabbage
      @thespicycabbage Před 11 měsíci +5

      not all heroes wear capes

    • @crossvalidation1040
      @crossvalidation1040 Před 11 měsíci +2

      Great video! Could you please also share the DP solution for this one?

    • @sumitsharma6738
      @sumitsharma6738 Před 11 měsíci

      You can upload your other videos that you say on podcast that I have a bunch of recorded videos to upload!!

    • @MP-ny3ep
      @MP-ny3ep Před 11 měsíci

      Yes, please continue with the daily leetcode problems. It's so helpful

    • @tianmingguo8271
      @tianmingguo8271 Před 11 měsíci +2

      Thanks for the explanation. The right boundary should be nums[-1]-nums[0] after sorted nums instead of 10**9. This will reduce the running cycles.

  • @michael._.
    @michael._. Před 11 měsíci +25

    *log is square root on steroids* - I can never forget this now

  • @michelle_tsai_drums
    @michelle_tsai_drums Před 11 měsíci +7

    lol "log is square root on steroids" brilliant solution with clear explanation as always, plz keep these daily challenges coming

  • @uptwist2260
    @uptwist2260 Před 11 měsíci +7

    Thanks for the daily
    Similar problems: (pattern is to binary search and test)
    875. Koko Eating Bananas
    1011. Capacity To Ship Packages Within D Days
    1870. Minimum Speed to Arrive on Time

  • @hengyulee4319
    @hengyulee4319 Před 11 měsíci +29

    A slight optimization can be binary searching the range from 0 to (max(arr) - min(arr)) as the max diff of any pair is bounded by this upper limit.

    • @tirthajrikame1052
      @tirthajrikame1052 Před 11 měsíci +1

      Nice catch!

    • @DanielRodrigues-bx6lr
      @DanielRodrigues-bx6lr Před 11 měsíci +5

      And since you've sorted the array, might as well just take the difference of (last element - first element).

    • @hengyulee4319
      @hengyulee4319 Před 11 měsíci

      @@DanielRodrigues-bx6lrexactly

    • @tirthajrikame1052
      @tirthajrikame1052 Před 11 měsíci +3

      @@DanielRodrigues-bx6lr yeah! I did the same thing, and this tweak made my code faster than 90%

  • @animesekai4229
    @animesekai4229 Před 11 měsíci +7

    It is really good, but we can choose the range as 0 to (arr[length - 1] - arr[0]) coz the maximum result we get is the diff between last and first elements.

  • @utkarshsinh1919
    @utkarshsinh1919 Před 11 měsíci

    It's great to see you back!

  • @FluteVJ
    @FluteVJ Před 11 měsíci +1

    One more very small performance improvement is that we can avoid calling "abs" every time we find the difference. Instead we can just find the difference like nums[i+1]-nums[i] as the array is sorted now.

  • @panzach
    @panzach Před 11 měsíci +1

    (a + b) / 2 = a/2 + b/2 = a - a/2 + b/2 = a + (b-a)/2
    Just writing it as: `a/2 + b/2` would be both sufficient and easier (to graps) to prevent overflow.

  • @GuruPrasadShukla
    @GuruPrasadShukla Před 11 měsíci +2

    if we do l+r then their sum could overflow(be greater) than the max allowed capacity, so instead we take their difference and add it to the left pointer

  • @sumitsharma6738
    @sumitsharma6738 Před 11 měsíci +2

    Whenever we see in Question to Find Min(Max) or Max(Min) we will try to use Binary search and here in this question s = 0 and e = max element in my array;

  • @krateskim4169
    @krateskim4169 Před 11 měsíci

    Great video man

  • @vaishnavisahu3167
    @vaishnavisahu3167 Před 11 měsíci +4

    Hi there, please provide the dynamic programming solution also. (code reference or similar question solution will also work). Thanks!

  • @GuruPrasadShukla
    @GuruPrasadShukla Před 11 měsíci +2

    lots of support from india

  • @gouthamp9066
    @gouthamp9066 Před 11 měsíci +1

    can we have a feature to take only required courses from the website instead everything

  • @jessanraj9086
    @jessanraj9086 Před 11 měsíci

    Great video

  • @PabloEscobaro-jf8ib
    @PabloEscobaro-jf8ib Před 10 měsíci

    Constraints: 0

  • @vs3.14
    @vs3.14 Před 11 měsíci +5

    I have been following your 150 problems as well as leetcode's for the last 1.5 months. I have done around 80 (35 easy, 40 medium, 5 hard). But even still when I encounter a new problem in the medium or hard section from the topics I have covered till now(nothing from tree or dp or backtracking yet), I almost always have to lookup a solution. or I just wouldn't be able to solve it. I dunno if I am improving or not if I have to always look up a solution. I do revise the problems the next day. And try to solve them on my own if I had to take help on the first try. Is there any advice you could give?

    • @sumitsharma6738
      @sumitsharma6738 Před 11 měsíci +1

      write down your approach in google sheets or on paper to recall what you are thinking when you are trying to solve that problem earlier;

  • @bossmusa9075
    @bossmusa9075 Před 11 měsíci

    how can i be like you man, you are like genius or smth

  • @m3hdim3hdi
    @m3hdim3hdi Před 10 měsíci +1

    please someone give us the dynamic programming solution in python please

  • @dineshrajant4000
    @dineshrajant4000 Před 11 měsíci +2

    Can you explain that mid pointer why l + (r-l)/2 is preventing overflow

    • @ChrisCox-wv7oo
      @ChrisCox-wv7oo Před 8 měsíci +1

      Imagine you have a data type that overflows at 16 (valid range 0 to 15)
      Find the average of 10 and 8.
      (10 + 8) / 2 overflows when 10 is added to 8, because 18 is greater than 15.
      8 + (10 - 8) / 2 does not overflow, because you never risk adding two very large numbers.
      However, in Python I don't think integers can overflow. This is certainly a concern in languages like C++.

    • @deathbombs
      @deathbombs Před měsícem

      The alternative is using r+l /2. The r+l piece can over flow

  • @akankshasharma7498
    @akankshasharma7498 Před 11 měsíci +4

    idk why.... I am never able to solve problems like these by myself 😞

    • @yaswanth8973
      @yaswanth8973 Před 11 měsíci +1

      It needs lots of understanding and practice

  • @varswe
    @varswe Před 11 měsíci +2

    this should be a hard level question

  • @vanshrodge7670
    @vanshrodge7670 Před 5 měsíci

    The way he says log is sqare root on steroids🤣

  • @oksowhat
    @oksowhat Před 11 měsíci

    there is a test case in it where p=3 and the o/p is 1, how is it possible like the set of minimums at best can be [2,1,0] 2 is the correct answer how did you cleared that, its testcase some 400ish

  • @ronbuchanan5432
    @ronbuchanan5432 Před 9 měsíci +1

    Why is it suddenly OK to naively check only neighbours when the array is sorted? In your example you checked only the tuples (1, 1), (2,3), (7, 10). but you could for example start from (1, 2), (7, 3) ...
    I don't get it

  • @adilkhatri7475
    @adilkhatri7475 Před 11 měsíci

    just one question. how do you come up with the solutions. i have solved 400 leetcode problems. but still i find difficult to come up with this kind of solution.

    • @kareni7572
      @kareni7572 Před měsícem +1

      It’s part of a pattern in binary search. It’s called min of max. Also there’s max of min. So those types of questions are also phrased in that way

  • @GuruPrasadShukla
    @GuruPrasadShukla Před 11 měsíci +3

    log is square root on steroids😂

  • @dk4882
    @dk4882 Před 11 měsíci +2

    Sir please add these questions in NeetCode All Lists also .
    Then it will be convenient to have all problems in one place during the revision .

    • @metarus208
      @metarus208 Před 11 měsíci

      yes

    • @dk4882
      @dk4882 Před 11 měsíci

      @@mfizt2537 obviously I know it .
      But it will be more convenient if all questions are presented in one list .

    • @metarus208
      @metarus208 Před 11 měsíci

      @@dk4882 seconded

  • @lucifersenpai1948
    @lucifersenpai1948 Před 11 měsíci

    please explain your logic for m = l + (r - 1) // 2 instead of m = (l + r) // 2

    • @acidtoe1278
      @acidtoe1278 Před 8 měsíci

      It makes no difference in this specific situation, but if the numbers are really big, you can run into overflow problems.
      for instance if r is close to int_max, and l = 1/2 int_max, l + r will be greater than max_int.

  • @rustamkarimov1191
    @rustamkarimov1191 Před 11 měsíci

    l, r = 0, max(nums)

  • @yeah5037
    @yeah5037 Před 11 měsíci +1

    You talking slower is so much better to absorb!

  • @pradipakshar
    @pradipakshar Před 7 měsíci

    log is square root on steroids 🤣🤣🤣🤣

  • @metarus208
    @metarus208 Před 11 měsíci +4

    kinda a hard problem tbh

    • @NeetCodeIO
      @NeetCodeIO  Před 11 měsíci +3

      Agreed, especially the optimal solution

  • @j_curlin
    @j_curlin Před 11 měsíci

    I have attempted the solution below around 10 times. Time Limit exceeded on every attempt. I have reviewed over and over and can see absolutely no difference from your code.
    class Solution:
    def minimizeMax(self, nums: List[int], p: int) -> int:
    def isValid(threshold):
    i, count = 0, 0
    while i < len(nums) - 1:
    if abs(nums[i] - nums[i+1])

    • @j_curlin
      @j_curlin Před 11 měsíci

      reverting your (l+r) // 2 change ran without issue. Confused as to how you got 100% passed on this as I had no luck after many submission attempts.

  • @name_surname_1337
    @name_surname_1337 Před 8 měsíci

    10 ** 9 is cringe, you can't do in a real interview. so why do you show this? you should use right = nums[n - 1] - nums[0]

  • @doombringer1810
    @doombringer1810 Před 11 měsíci

    I don't get why scanning through the sorted array comparing each neighbours difference with a previously stored "min_value" shouldn't work... It's O(n)

    • @user-le6ts6ci7h
      @user-le6ts6ci7h Před 11 měsíci

      The minimum distance of a value with a neighbour could fall on either side of it , which we are not sure about,

    • @doombringer1810
      @doombringer1810 Před 11 měsíci

      ​@@user-le6ts6ci7h Yeah, but if we compute the difference between the ith and i+1th elements of the array and take the minimum value between that difference and the "min_malue " you should check on either side of the number.
      In the case of [1, 2, 4] you check 1-2 when i = 1, and 2-4 when i = 2

    • @user-le6ts6ci7h
      @user-le6ts6ci7h Před 11 měsíci +1

      Yeah ,I got you, but , keeping on updating the minimum variable doesn't help us, this is right approach , if you have been asked to find the minimum difference between any single pair , but the question is to minimum diff, and you must choose p pairs , not one, I hope this helps

    • @doombringer1810
      @doombringer1810 Před 11 měsíci

      ​@@user-le6ts6ci7hOh that was the missing piece, thanks!!
      I guess that to extend my solution to have multiple pairs we could use a min heap to store n lowest values then!